(*
** System F
*)

(* mu[Ty:Nat->Set](t_var : {n|Nat}(Fin n) -> (Ty n),
		   arr   : {n|Nat}(Ty n) -> (Ty n) -> (Ty n),
		   pi    : {n|Nat}(Ty (succ n)) -> (Ty n) )
*)

$[Ty : Nat -> Set]
$[t_var : {n|Nat}(Fin n) -> (Ty n)]
$[arr : {n|Nat}(Ty n) -> (Ty n) -> (Ty n)]
$[pi : {n|Nat}(Ty (succ n)) -> (Ty n)];

$[RecTy : {P:{n|Nat}(Ty n)->Type}
	   ({n|Nat}{p:Fin n} P (t_var p))
	-> ({n|Nat}{M:Ty n}(P M) -> {N:Ty n}(P N) -> (P (arr M N)))
	-> ({n|Nat}{M:Ty (succ n)}(P M) -> (P (pi M)))
	-> {n|Nat}{M:Ty n}P M];

[[P:{n|Nat}(Ty n)->Type]
 [f0:{n|Nat}{p:Fin n} P (t_var p)]
 [f1:{n|Nat}{M:Ty n}(P M) -> {N:Ty n}(P N) -> (P (arr M N))]
 [f2:{n|Nat}{M:Ty (succ n)}(P M) -> (P (pi M))]
 [n:Nat][p:Fin n][M,N:Ty n][O:Ty (succ n)]
   RecTy P f0 f1 f2 (t_var p) ==> f0 p
|| RecTy P f0 f1 f2 (arr M N) ==> f1 M (RecTy P f0 f1 f2 M)
				     N (RecTy P f0 f1 f2 N)
|| RecTy P f0 f1 f2 (pi O) ==> f2 O (RecTy P f0 f1 f2 O)];

[RecTyN [P:Nat->Type] = RecTy ([n|Nat][_:Ty n]P n)
 : ({n|Nat}(Fin n)->P n)
 ->({n|Nat}(Ty n)->(P n)->(Ty n)->(P n)->P n)
 ->({n|Nat}(Ty (succ n))->(P (succ n))->P n)
 ->{n|Nat}(Ty n)->P n];

(*
** Special recursors for Ty
*)

Goal  {n:Nat}{P:{l:Nat}(Ty (add l n))->Set}
	   ({l:Nat}{p:Fin (add l n)} P l (t_var p))
	-> ({l:Nat}{M:Ty (add l n)}(P l M) 
	        -> {N:Ty (add l n)}(P l N) 
		-> (P l (arr M N)))
	-> ({l:Nat}{M:Ty (succ (add l n))}(P (succ l) M) 
		-> (P l (pi M)))
	-> {l:Nat}{M:Ty (add l n)}P l M;
intros;
Claim {l'|Nat}{M':Ty l'}{l:Nat}{q:EQ l' (add l n)}
	P l (EQ_rewrite q Ty M');
Refine ?+1 M l (EQ_refl ?);
Refine RecTy [l'|Nat][M':Ty l']{l:Nat}{q:EQ l' (add l n)}
	P l (EQ_rewrite q Ty M');
(* t_var *)
intros;
Refine RecEQ1 (add l1 n)
	[n1:Nat][q:EQ n1 (add l1 n)]
	{p:Fin n1}P l1 (EQ_rewrite q Ty (t_var p));
Refine H;
(* arr *)
intros;
Refine RecEQ1 (add l1 n)
	[n1:Nat][q:EQ n1 (add l1 n)]
	{M1:Ty n1}(P l1 (EQ_rewrite q Ty M1))
	 -> {N:Ty n1}(P l1 (EQ_rewrite q Ty N))
	 -> (P l1 (EQ_rewrite q Ty (arr M1 N)));
Refine H1;
Refine H3;Refine H4;
(* pi *)
intros;
Refine RecEQ1 (add l1 n)
	[n1:Nat][q:EQ n1 (add l1 n)]
	{M1 : Ty (succ n1)}(P (succ l1) (EQ_rewrite (EQ_resp succ q) Ty M1))
	-> P l1 (EQ_rewrite q Ty (pi M1));
Refine H2;
Refine H3 (succ l1) (EQ_resp succ q);
Save RecTy1;

[RecTy1N [n:Nat][P:Nat->Set] = RecTy1 n ([l:Nat][_:Ty (add l n)]P l)
 : ({l:Nat}(Fin (add l n))->P l)
 ->({l:Nat}(Ty (add l n))->(P l)->(Ty (add l n))->(P l)->P l)
 ->({l:Nat}(Ty (succ (add l n)))->(P (succ l))->P l)
 ->{l:Nat}(Ty (add l n))->P l];

Goal  {n:Nat}{P:{l:Nat}(Ty (succ (add l n)))->Set}
	   ({l:Nat}{p:Fin (succ (add l n))} P l (t_var p))
	-> ({l:Nat}{M:Ty (add (succ l) n)}(P l M) 
	        -> {N:Ty (add (succ l) n)}(P l N) 
		-> (P l (arr M N)))
	-> ({l:Nat}{M:Ty (succ (succ (add l n)))}(P (succ l) M) 
		-> (P l (pi M)))
	-> {l:Nat}{M:Ty (succ (add l n))}P l M;
intros;
Claim {l'|Nat}{M':Ty l'}{l:Nat}{q:EQ l' (succ (add l n))}
	P l (EQ_rewrite q Ty M');
Refine ?+1 M l (EQ_refl ?);
Refine RecTy [l'|Nat][M':Ty l']{l:Nat}{q:EQ l' (succ (add l n))}
	P l (EQ_rewrite q Ty M');
(* t_var *)
intros;
Refine RecEQ1 (succ (add l1 n))
	[n1:Nat][q:EQ n1 (succ (add l1 n))]
	{p:Fin n1}P l1 (EQ_rewrite q Ty (t_var p));
Refine H;
(* arr *)
intros;
Refine RecEQ1 (succ (add l1 n))
	[n1:Nat][q:EQ n1 (succ (add l1 n))]
	{M1:Ty n1}(P l1 (EQ_rewrite q Ty M1))
	 -> {N:Ty n1}(P l1 (EQ_rewrite q Ty N))
	 -> (P l1 (EQ_rewrite q Ty (arr M1 N)));
Refine H1;
Refine H3;Refine H4;
(* pi *)
intros;
Refine RecEQ1 (succ (add l1 n))
	[n1:Nat][q:EQ n1 (succ (add l1 n))]
	{M1 : Ty (succ n1)}(P (succ l1) (EQ_rewrite (EQ_resp succ q) Ty M1))
	-> P l1 (EQ_rewrite q Ty (pi M1));
Refine H2;
Refine H3 (succ l1) (EQ_resp succ q);
Save RecTy2;

[RecTy2N [n:Nat][P:Nat->Set] = RecTy2 n ([l:Nat][_:Ty (succ (add l n))]P l)
 : ({l:Nat}(Fin (succ (add l n)))->P l)
 ->({l:Nat}(Ty (add (succ l) n))->(P l)
 ->(Ty (add (succ l) n))->(P l)->P l)
 ->({l:Nat}(Ty (succ (succ (add l n))))->(P (succ l))->P l)
 ->{l:Nat}(Ty (succ (add l n)))->P l];

(* 
** weakening & substitution for Types
*)

[n|Nat];

(* t_weak_var : {l:Nat}(Fin (add l n))->(Fin (succ (add l n)))

rec t_weak_var zero     i = (f_succ i)
  | t_weak_var (succ l) (f_zero (add l n)) = f_zero (succ (add l n))
  | t_weak_var (succ l) (f_succ i) = f_succ (t_weak_var l i)

*)

[t_weak_var =
  [P[l:Nat] = (Fin (add l n))->(Fin (succ (add l n)))]
  RecNat P (f_succ|n)
	([l:Nat][t_weak_var_l:P l]
	   RecFin1N (add l n)
	      (f_zero (succ (add l n)))
	      ([i:Fin (add l n)]f_succ (t_weak_var_l i)))
 : {l:Nat}(Fin (add l n))->(Fin (succ (add l n)))];

(* t_weak : {l|Nat}(Tm (add l n))->(Ty (succ (add l n))) 

rec t_weak l (t_var i) = t_var (t_weak_var l i)
  | t_weak l (arr M N) = arr (t_weak l M) (t_weak l N)
  | t_weak l (abs M) = pi (t_weak (succ l) M)
*)

[t_weak = 
  [P[l:Nat] = Ty (succ (add l n))]
  RecTy1N n P
	([l:Nat][i:Fin (add l n)]t_var (t_weak_var l i))
	([l:Nat][_:Ty (add l n)][t_weak_M:P l]
		[_:Ty (add l n)][t_weak_N:P l]arr t_weak_M t_weak_N)
	([l:Nat][_:Ty (add (succ l) n)][t_weak_M:P (succ l)]pi t_weak_M)
  :  {l|Nat}(Ty (add l n))->Ty (succ (add l n))];
	
[t_weak0 = t_weak|zero 
 : (Ty n) -> (Ty (succ n))];

DischargeKeep n;

(* t_subst_var : {l:Nat}(Fin (add (succ l) n))->(Ty n)->(Ty (add l n))

rec t_subst_var zero (f_zero (succ n)) = N
  | t_subst_var zero (f_succ i) = (t_var i)
  | t_subst_var (succ l) (f_zero (add (succ l) n)) =
	t_var (f_zero (add l n))
  | t_subst_var (succ l) (f_succ i) = t_weak0 (t_subst_var l i)
*)

[t_subst_var[l:Nat][i:Fin (add (succ l) n)][N:Ty n] =
  [P[l:Nat] = (Fin (add (succ l) n))->(Ty (add l n))]
  RecNat P
    (RecFin1N n N (t_var|n))
    ([l:Nat][t_subst_var_l:P l]
	RecFin1N (add (succ l) n)
	   (t_var (f_zero (add l n)))
	   ([i:Fin (add (succ l) n)]t_weak0 (t_subst_var_l i))) 
   l i];

(* t_subst : {l:Nat}(Ty (add (succ l) n))->(Ty n)->(Ty (add l n))

rec t_subst l (var i) = t_subst_t_var l i
  | t_subst l (arr M1 M2) = arr (t_subst l M1) (t_subst l M2)
  | t_subst l (abs M) = abs (t_subst (succ l) M)
*)

[t_subst[l|Nat][M:Ty (add (succ l) n)][N:Ty n] =
  [P[l:Nat] = Ty (add l n)]
  RecTy2N n P
  ([l:Nat][i:Fin (succ (add l n))]t_subst_var l i N)
  ([l:Nat][_:Ty (succ (add l n))][t_subst_M1:P l]
	  [_:Ty (succ (add l n))][t_subst_M2:P l]arr t_subst_M1 t_subst_M2)
  ([l:Nat][_:Ty (succ (add (succ l) n))][t_subst_M:P (succ l)]pi t_subst_M)
    l M
  : Ty (add l n)];

[t_subst0 = t_subst|zero : (Ty (succ n)) -> (Ty n) -> (Ty n)];

Discharge n;

(* 
** Derivations 
*)

[Con[m:Nat] = Vec (Ty m)];

(* mu[Der:{m,n|Nat}(Con m n)->Tm->(Ty m)->Set](
	Var : {m,n|Nat}{G:Con m n}{i:Fin n}
		Der G (var (Fin2Nat i)) (v_nth i G)
	App : {m,n|Nat}{G|Con m n}{s,t|Ty m}{M,N|Tm}
		(Der G M (arr s t))
		-> (Der G N s)
		-> (Der G (app M N) t)
	Lam : {m,n|Nat}{G|Con m n}{s,t|Ty m}{M|Tm}
		(Der (v_cons s G) M t)
		-> (Der G (lam M) (arr s t))
	Pi_e: {m,n|Nat}{G|Con m n}{s:Ty (succ m)}{t:Ty m}{M|Tm}
		(Der G M (pi s))
		-> (Der G M (t_subst0 s t))
	Pi_i: {m,n|Nat}{G|Con m n}{s:Ty (succ m)}{M|Tm}
		(Der (v_map t_weak0 G) M s)
		-> (Der G M (pi s)) )
*)

$[Der:{m,n|Nat}(Con m n)->Tm->(Ty m)->Set]
$[Var:  {m,n|Nat}{G:Con m n}{i:Fin n}
		Der G (var (Fin2Nat i)) (v_nth i G)]
$[App : {m,n|Nat}{G|Con m n}{s,t|Ty m}{M,N|Tm}
		(Der G M (arr s t))
		-> (Der G N s)
		-> (Der G (app M N) t)]
$[Lam : {m,n|Nat}{G|Con m n}{s,t|Ty m}{M|Tm}
		(Der (v_cons s G) M t)
		-> (Der G (lam M) (arr s t))]
$[Pi_e: {m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		(Der G M (pi s))
		-> {t:Ty m}(Der G M (t_subst0 s t))]
$[Pi_i: {m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		(Der (v_map (t_weak0|m) G) M s)
		-> (Der G M (pi s))];

$[RecDer : {P:{m,n|Nat}{G|Con m n}{M|Tm}{s|Ty m}(Der G M s)->Type}
	({m,n|Nat}{G:Con m n}{i:Fin n}P (Var G i))
	-> ({m,n|Nat}{G|Con m n}{s,t|Ty m}{M,N|Tm}
		{d1:Der G M (arr s t)}(P d1)
		-> {d2:Der G N s}(P d2)
		-> P (App d1 d2))
	-> ({m,n|Nat}{G|Con m n}{s,t|Ty m}{M|Tm}
		{d:Der (v_cons s G) M t}(P d)
		-> P (Lam d))
	-> ({m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		{d:Der G M (pi s)}(P d)
		-> {t:Ty m}P (Pi_e d t))
	-> ({m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		{d:Der (v_map (t_weak0|m) G) M s}(P d)
		-> P (Pi_i d))
	-> {m,n|Nat}{G|Con m n}{M|Tm}{s|Ty m}{d:Der G M s}P d];

[RecDerN [P:{m,n|Nat}(Con m n)->Tm->(Ty m)->Type] =
  RecDer [m,n|Nat][G:Con m n][M:Tm][s:Ty m][_:Der G M s]P G M s
 : ({m,n|Nat}{G:Con m n}{i:Fin n}P G (var (Fin2Nat i)) (v_nth i G))
->({m,n|Nat}{G|Con m n}{s,t|Ty m}{M,N|Tm}(Der G M (arr s t))
	->(P G M (arr s t))->(Der G N s)->(P G N s)->P G (app M N) t)
->({m,n|Nat}{G|Con m n}{s,t|Ty m}{M|Tm}(Der (v_cons s G) M t)
	->(P (v_cons s G) M t)->P G (lam M) (arr s t))->
({m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}(Der G M (pi s))
	->(P G M (pi s))->{t:Ty m}P G M (t_subst0 s t))
->({m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}(Der (v_map (t_weak0|m) G) M s)
	->(P (v_map (t_weak0|m) G) M s)->P G M (pi s))
->{m,n|Nat}{G|Con m n}{M|Tm}{s|Ty m}(Der G M s)->P G M s];

[[P:{m,n|Nat}{G|Con m n}{M|Tm}{s|Ty m}(Der G M s)->Type]
 [Var_:{m,n|Nat}{G:Con m n}{i:Fin n}P (Var G i)]
 [App_:{m,n|Nat}{G|Con m n}{s,t|Ty m}{M,N|Tm}
		{d1:Der G M (arr s t)}(P d1)
		-> {d2:Der G N s}(P d2)
		-> P (App d1 d2)]
 [Lam_:{m,n|Nat}{G|Con m n}{s,t|Ty m}{M|Tm}
		{d:Der (v_cons s G) M t}(P d)
		-> P (Lam d)]
 [Pi_e_:{m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		{d:Der G M (pi s)}(P d)
		-> {t:Ty m}P (Pi_e d t)]
 [Pi_i_:{m,n|Nat}{G|Con m n}{s|Ty (succ m)}{M|Tm}
		{d:Der (v_map (t_weak0|m) G) M s}(P d)
		-> P (Pi_i d)]
 [m,n|Nat][G:Con m n][i:Fin n][s,t:Ty m][s':Ty (succ m)][M,N|Tm]
 [d1:Der G M (arr s t)][d2:Der G N s][d3:Der (v_cons s G) M t]
 [d4:Der G M (pi s')][d5:Der (v_map (t_weak0|m) G) M s']
   RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ (Var G i) ==> Var_ G i
|| RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ (App d1 d2) ==> 
	App_ d1 (RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ d1)
	     d2 (RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ d2)
|| RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ (Lam d3) ==>
	Lam_ d3 (RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ d3)
|| RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ (Pi_e d4 t) ==>
	Pi_e_ d4 (RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ d4) t
|| RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ (Pi_i d5) ==>
	Pi_i_ d5 (RecDer P Var_ App_ Lam_ Pi_e_ Pi_i_ d5)
];


